
/*!
[config]
name: Vector store char2,4,8,16
clc_version_min: 10

dimensions: 1
global_size: 1 0 0

[test]
name: vector store global char2
kernel_name: vstore2_global
arg_out: 0 buffer char[3] 0 244 242
arg_in:  1 buffer char2[1] 244 242

[test]
name: vector store global offset char2
kernel_name: vstore2_global_offset
arg_out: 0 buffer char[5] 0 0 0  244 242
arg_in:  1 buffer char2[1] 244 242

[test]
name: vector store global char4
kernel_name: vstore4_global
arg_out: 0 buffer char[5] 0 60 26 101 39
arg_in:  1 buffer char4[1] 60 26 101 39

[test]
name: vector store global offset char4
kernel_name: vstore4_global_offset
arg_out: 0 buffer char[9] 0 0 0 0 0  60 26 101 39
arg_in:  1 buffer char4[1] 60 26 101 39

[test]
name: vector store global char8
kernel_name: vstore8_global
arg_out: 0 buffer char[9] 0 58 246 32 180 21 63 255 53
arg_in:  1 buffer char8[1] 58 246 32 180 21 63 255 53

[test]
name: vector store global offset char8
kernel_name: vstore8_global_offset
arg_out: 0 buffer char[17] 0 0 0 0 0 0 0 0 0  58 246 32 180 21 63 255 53
arg_in:  1 buffer char8[1] 58 246 32 180 21 63 255 53

[test]
name: vector store global char16
kernel_name: vstore16_global
arg_out: 0 buffer char[17] 0 92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244
arg_in:  1 buffer char16[1] 92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244

[test]
name: vector store global offset char16
kernel_name: vstore16_global_offset
arg_out: 0 buffer char[33] 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244
arg_in:  1 buffer char16[1] 92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244

!*/

kernel void vstore2_global(global char *out,
                             global char2 *in) {
    char2 tmp = in[0];
    vstore2((char2)0, 0, out);
    vstore2(tmp, 0, out + 1);
}

kernel void vstore2_global_offset(global char *out,
                                    global char2 *in) {
    char2 tmp = (char2)0;
    vstore2(tmp, 0, out);
    vstore2(tmp, 0, out + 1);
    tmp = in[0];
    vstore2(tmp, 1, out + 1);
}

kernel void vstore4_global(global char *out,
                             global char4 *in) {
    char4 tmp = in[0];
    vstore4((char4)0, 0, out);
    vstore4(tmp, 0, out + 1);
}

kernel void vstore4_global_offset(global char *out,
                                    global char4 *in) {
    char4 tmp = (char4)0;
    vstore4(tmp, 0, out);
    vstore4(tmp, 0, out + 1);
    tmp = in[0];
    vstore4(tmp, 1, out + 1);
}

kernel void vstore8_global(global char *out,
                             global char8 *in) {
    char8 tmp = in[0];
    vstore8((char8)0, 0, out);
    vstore8(tmp, 0, out + 1);
}

kernel void vstore8_global_offset(global char *out,
                                    global char8 *in) {
    char8 tmp = (char8)0;
    vstore8(tmp, 0, out);
    vstore8(tmp, 0, out + 1);
    tmp = in[0];
    vstore8(tmp, 1, out + 1);
}

kernel void vstore16_global(global char *out,
                             global char16 *in) {
    char16 tmp = in[0];
    vstore16((char16)0, 0, out);
    vstore16(tmp, 0, out + 1);
}

kernel void vstore16_global_offset(global char *out,
                                    global char16 *in) {
    char16 tmp = (char16)0;
    vstore16(tmp, 0, out);
    vstore16(tmp, 0, out + 1);
    tmp = in[0];
    vstore16(tmp, 1, out + 1);
}
