
/*!
[config]
name: Vector store double2,4,8,16
clc_version_min: 10

dimensions: 1
global_size: 1 0 0
require_device_extensions: cl_khr_fp64
[test]
name: vector store global double2
kernel_name: vstore2_global
arg_out: 0 buffer double[3] 0 244 242
arg_in:  1 buffer double2[1] 244 242

[test]
name: vector store global offset double2
kernel_name: vstore2_global_offset
arg_out: 0 buffer double[5] 0 0 0  244 242
arg_in:  1 buffer double2[1] 244 242

[test]
name: vector store global double4
kernel_name: vstore4_global
arg_out: 0 buffer double[5] 0 60 26 101 39
arg_in:  1 buffer double4[1] 60 26 101 39

[test]
name: vector store global offset double4
kernel_name: vstore4_global_offset
arg_out: 0 buffer double[9] 0 0 0 0 0  60 26 101 39
arg_in:  1 buffer double4[1] 60 26 101 39

[test]
name: vector store global double8
kernel_name: vstore8_global
arg_out: 0 buffer double[9] 0 58 246 32 180 21 63 255 53
arg_in:  1 buffer double8[1] 58 246 32 180 21 63 255 53

[test]
name: vector store global offset double8
kernel_name: vstore8_global_offset
arg_out: 0 buffer double[17] 0 0 0 0 0 0 0 0 0  58 246 32 180 21 63 255 53
arg_in:  1 buffer double8[1] 58 246 32 180 21 63 255 53

[test]
name: vector store global double16
kernel_name: vstore16_global
arg_out: 0 buffer double[17] 0 92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244
arg_in:  1 buffer double16[1] 92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244

[test]
name: vector store global offset double16
kernel_name: vstore16_global_offset
arg_out: 0 buffer double[33] 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244
arg_in:  1 buffer double16[1] 92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244

!*/

#pragma OPENCL EXTENSION cl_khr_fp64: enable

kernel void vstore2_global(global double *out,
                             global double2 *in) {
    double2 tmp = in[0];
    vstore2((double2)0, 0, out);
    vstore2(tmp, 0, out + 1);
}

kernel void vstore2_global_offset(global double *out,
                                    global double2 *in) {
    double2 tmp = (double2)0;
    vstore2(tmp, 0, out);
    vstore2(tmp, 0, out + 1);
    tmp = in[0];
    vstore2(tmp, 1, out + 1);
}

kernel void vstore4_global(global double *out,
                             global double4 *in) {
    double4 tmp = in[0];
    vstore4((double4)0, 0, out);
    vstore4(tmp, 0, out + 1);
}

kernel void vstore4_global_offset(global double *out,
                                    global double4 *in) {
    double4 tmp = (double4)0;
    vstore4(tmp, 0, out);
    vstore4(tmp, 0, out + 1);
    tmp = in[0];
    vstore4(tmp, 1, out + 1);
}

kernel void vstore8_global(global double *out,
                             global double8 *in) {
    double8 tmp = in[0];
    vstore8((double8)0, 0, out);
    vstore8(tmp, 0, out + 1);
}

kernel void vstore8_global_offset(global double *out,
                                    global double8 *in) {
    double8 tmp = (double8)0;
    vstore8(tmp, 0, out);
    vstore8(tmp, 0, out + 1);
    tmp = in[0];
    vstore8(tmp, 1, out + 1);
}

kernel void vstore16_global(global double *out,
                             global double16 *in) {
    double16 tmp = in[0];
    vstore16((double16)0, 0, out);
    vstore16(tmp, 0, out + 1);
}

kernel void vstore16_global_offset(global double *out,
                                    global double16 *in) {
    double16 tmp = (double16)0;
    vstore16(tmp, 0, out);
    vstore16(tmp, 0, out + 1);
    tmp = in[0];
    vstore16(tmp, 1, out + 1);
}
