
/*!
[config]
name: Vector store int2,4,8,16
clc_version_min: 10

dimensions: 1
global_size: 1 0 0

[test]
name: vector store global int2
kernel_name: vstore2_global
arg_out: 0 buffer int[3] 0 244 242
arg_in:  1 buffer int2[1] 244 242

[test]
name: vector store global offset int2
kernel_name: vstore2_global_offset
arg_out: 0 buffer int[5] 0 0 0  244 242
arg_in:  1 buffer int2[1] 244 242

[test]
name: vector store global int4
kernel_name: vstore4_global
arg_out: 0 buffer int[5] 0 60 26 101 39
arg_in:  1 buffer int4[1] 60 26 101 39

[test]
name: vector store global offset int4
kernel_name: vstore4_global_offset
arg_out: 0 buffer int[9] 0 0 0 0 0  60 26 101 39
arg_in:  1 buffer int4[1] 60 26 101 39

[test]
name: vector store global int8
kernel_name: vstore8_global
arg_out: 0 buffer int[9] 0 58 246 32 180 21 63 255 53
arg_in:  1 buffer int8[1] 58 246 32 180 21 63 255 53

[test]
name: vector store global offset int8
kernel_name: vstore8_global_offset
arg_out: 0 buffer int[17] 0 0 0 0 0 0 0 0 0  58 246 32 180 21 63 255 53
arg_in:  1 buffer int8[1] 58 246 32 180 21 63 255 53

[test]
name: vector store global int16
kernel_name: vstore16_global
arg_out: 0 buffer int[17] 0 92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244
arg_in:  1 buffer int16[1] 92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244

[test]
name: vector store global offset int16
kernel_name: vstore16_global_offset
arg_out: 0 buffer int[33] 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244
arg_in:  1 buffer int16[1] 92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244

!*/

kernel void vstore2_global(global int *out,
                             global int2 *in) {
    int2 tmp = in[0];
    vstore2((int2)0, 0, out);
    vstore2(tmp, 0, out + 1);
}

kernel void vstore2_global_offset(global int *out,
                                    global int2 *in) {
    int2 tmp = (int2)0;
    vstore2(tmp, 0, out);
    vstore2(tmp, 0, out + 1);
    tmp = in[0];
    vstore2(tmp, 1, out + 1);
}

kernel void vstore4_global(global int *out,
                             global int4 *in) {
    int4 tmp = in[0];
    vstore4((int4)0, 0, out);
    vstore4(tmp, 0, out + 1);
}

kernel void vstore4_global_offset(global int *out,
                                    global int4 *in) {
    int4 tmp = (int4)0;
    vstore4(tmp, 0, out);
    vstore4(tmp, 0, out + 1);
    tmp = in[0];
    vstore4(tmp, 1, out + 1);
}

kernel void vstore8_global(global int *out,
                             global int8 *in) {
    int8 tmp = in[0];
    vstore8((int8)0, 0, out);
    vstore8(tmp, 0, out + 1);
}

kernel void vstore8_global_offset(global int *out,
                                    global int8 *in) {
    int8 tmp = (int8)0;
    vstore8(tmp, 0, out);
    vstore8(tmp, 0, out + 1);
    tmp = in[0];
    vstore8(tmp, 1, out + 1);
}

kernel void vstore16_global(global int *out,
                             global int16 *in) {
    int16 tmp = in[0];
    vstore16((int16)0, 0, out);
    vstore16(tmp, 0, out + 1);
}

kernel void vstore16_global_offset(global int *out,
                                    global int16 *in) {
    int16 tmp = (int16)0;
    vstore16(tmp, 0, out);
    vstore16(tmp, 0, out + 1);
    tmp = in[0];
    vstore16(tmp, 1, out + 1);
}
