
/*!
[config]
name: Vector store long2,4,8,16
clc_version_min: 10

dimensions: 1
global_size: 1 0 0

[test]
name: vector store global long2
kernel_name: vstore2_global
arg_out: 0 buffer long[3] 0 244 242
arg_in:  1 buffer long2[1] 244 242

[test]
name: vector store global offset long2
kernel_name: vstore2_global_offset
arg_out: 0 buffer long[5] 0 0 0  244 242
arg_in:  1 buffer long2[1] 244 242

[test]
name: vector store global long4
kernel_name: vstore4_global
arg_out: 0 buffer long[5] 0 60 26 101 39
arg_in:  1 buffer long4[1] 60 26 101 39

[test]
name: vector store global offset long4
kernel_name: vstore4_global_offset
arg_out: 0 buffer long[9] 0 0 0 0 0  60 26 101 39
arg_in:  1 buffer long4[1] 60 26 101 39

[test]
name: vector store global long8
kernel_name: vstore8_global
arg_out: 0 buffer long[9] 0 58 246 32 180 21 63 255 53
arg_in:  1 buffer long8[1] 58 246 32 180 21 63 255 53

[test]
name: vector store global offset long8
kernel_name: vstore8_global_offset
arg_out: 0 buffer long[17] 0 0 0 0 0 0 0 0 0  58 246 32 180 21 63 255 53
arg_in:  1 buffer long8[1] 58 246 32 180 21 63 255 53

[test]
name: vector store global long16
kernel_name: vstore16_global
arg_out: 0 buffer long[17] 0 92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244
arg_in:  1 buffer long16[1] 92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244

[test]
name: vector store global offset long16
kernel_name: vstore16_global_offset
arg_out: 0 buffer long[33] 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244
arg_in:  1 buffer long16[1] 92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244

!*/

kernel void vstore2_global(global long *out,
                             global long2 *in) {
    long2 tmp = in[0];
    vstore2((long2)0, 0, out);
    vstore2(tmp, 0, out + 1);
}

kernel void vstore2_global_offset(global long *out,
                                    global long2 *in) {
    long2 tmp = (long2)0;
    vstore2(tmp, 0, out);
    vstore2(tmp, 0, out + 1);
    tmp = in[0];
    vstore2(tmp, 1, out + 1);
}

kernel void vstore4_global(global long *out,
                             global long4 *in) {
    long4 tmp = in[0];
    vstore4((long4)0, 0, out);
    vstore4(tmp, 0, out + 1);
}

kernel void vstore4_global_offset(global long *out,
                                    global long4 *in) {
    long4 tmp = (long4)0;
    vstore4(tmp, 0, out);
    vstore4(tmp, 0, out + 1);
    tmp = in[0];
    vstore4(tmp, 1, out + 1);
}

kernel void vstore8_global(global long *out,
                             global long8 *in) {
    long8 tmp = in[0];
    vstore8((long8)0, 0, out);
    vstore8(tmp, 0, out + 1);
}

kernel void vstore8_global_offset(global long *out,
                                    global long8 *in) {
    long8 tmp = (long8)0;
    vstore8(tmp, 0, out);
    vstore8(tmp, 0, out + 1);
    tmp = in[0];
    vstore8(tmp, 1, out + 1);
}

kernel void vstore16_global(global long *out,
                             global long16 *in) {
    long16 tmp = in[0];
    vstore16((long16)0, 0, out);
    vstore16(tmp, 0, out + 1);
}

kernel void vstore16_global_offset(global long *out,
                                    global long16 *in) {
    long16 tmp = (long16)0;
    vstore16(tmp, 0, out);
    vstore16(tmp, 0, out + 1);
    tmp = in[0];
    vstore16(tmp, 1, out + 1);
}
