
/*!
[config]
name: Vector store short2,4,8,16
clc_version_min: 10

dimensions: 1
global_size: 1 0 0

[test]
name: vector store global short2
kernel_name: vstore2_global
arg_out: 0 buffer short[3] 0 244 242
arg_in:  1 buffer short2[1] 244 242

[test]
name: vector store global offset short2
kernel_name: vstore2_global_offset
arg_out: 0 buffer short[5] 0 0 0  244 242
arg_in:  1 buffer short2[1] 244 242

[test]
name: vector store global short4
kernel_name: vstore4_global
arg_out: 0 buffer short[5] 0 60 26 101 39
arg_in:  1 buffer short4[1] 60 26 101 39

[test]
name: vector store global offset short4
kernel_name: vstore4_global_offset
arg_out: 0 buffer short[9] 0 0 0 0 0  60 26 101 39
arg_in:  1 buffer short4[1] 60 26 101 39

[test]
name: vector store global short8
kernel_name: vstore8_global
arg_out: 0 buffer short[9] 0 58 246 32 180 21 63 255 53
arg_in:  1 buffer short8[1] 58 246 32 180 21 63 255 53

[test]
name: vector store global offset short8
kernel_name: vstore8_global_offset
arg_out: 0 buffer short[17] 0 0 0 0 0 0 0 0 0  58 246 32 180 21 63 255 53
arg_in:  1 buffer short8[1] 58 246 32 180 21 63 255 53

[test]
name: vector store global short16
kernel_name: vstore16_global
arg_out: 0 buffer short[17] 0 92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244
arg_in:  1 buffer short16[1] 92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244

[test]
name: vector store global offset short16
kernel_name: vstore16_global_offset
arg_out: 0 buffer short[33] 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244
arg_in:  1 buffer short16[1] 92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244

!*/

kernel void vstore2_global(global short *out,
                             global short2 *in) {
    short2 tmp = in[0];
    vstore2((short2)0, 0, out);
    vstore2(tmp, 0, out + 1);
}

kernel void vstore2_global_offset(global short *out,
                                    global short2 *in) {
    short2 tmp = (short2)0;
    vstore2(tmp, 0, out);
    vstore2(tmp, 0, out + 1);
    tmp = in[0];
    vstore2(tmp, 1, out + 1);
}

kernel void vstore4_global(global short *out,
                             global short4 *in) {
    short4 tmp = in[0];
    vstore4((short4)0, 0, out);
    vstore4(tmp, 0, out + 1);
}

kernel void vstore4_global_offset(global short *out,
                                    global short4 *in) {
    short4 tmp = (short4)0;
    vstore4(tmp, 0, out);
    vstore4(tmp, 0, out + 1);
    tmp = in[0];
    vstore4(tmp, 1, out + 1);
}

kernel void vstore8_global(global short *out,
                             global short8 *in) {
    short8 tmp = in[0];
    vstore8((short8)0, 0, out);
    vstore8(tmp, 0, out + 1);
}

kernel void vstore8_global_offset(global short *out,
                                    global short8 *in) {
    short8 tmp = (short8)0;
    vstore8(tmp, 0, out);
    vstore8(tmp, 0, out + 1);
    tmp = in[0];
    vstore8(tmp, 1, out + 1);
}

kernel void vstore16_global(global short *out,
                             global short16 *in) {
    short16 tmp = in[0];
    vstore16((short16)0, 0, out);
    vstore16(tmp, 0, out + 1);
}

kernel void vstore16_global_offset(global short *out,
                                    global short16 *in) {
    short16 tmp = (short16)0;
    vstore16(tmp, 0, out);
    vstore16(tmp, 0, out + 1);
    tmp = in[0];
    vstore16(tmp, 1, out + 1);
}
