
/*!
[config]
name: Vector store uchar2,4,8,16
clc_version_min: 10

dimensions: 1
global_size: 1 0 0

[test]
name: vector store global uchar2
kernel_name: vstore2_global
arg_out: 0 buffer uchar[3] 0 244 242
arg_in:  1 buffer uchar2[1] 244 242

[test]
name: vector store global offset uchar2
kernel_name: vstore2_global_offset
arg_out: 0 buffer uchar[5] 0 0 0  244 242
arg_in:  1 buffer uchar2[1] 244 242

[test]
name: vector store global uchar4
kernel_name: vstore4_global
arg_out: 0 buffer uchar[5] 0 60 26 101 39
arg_in:  1 buffer uchar4[1] 60 26 101 39

[test]
name: vector store global offset uchar4
kernel_name: vstore4_global_offset
arg_out: 0 buffer uchar[9] 0 0 0 0 0  60 26 101 39
arg_in:  1 buffer uchar4[1] 60 26 101 39

[test]
name: vector store global uchar8
kernel_name: vstore8_global
arg_out: 0 buffer uchar[9] 0 58 246 32 180 21 63 255 53
arg_in:  1 buffer uchar8[1] 58 246 32 180 21 63 255 53

[test]
name: vector store global offset uchar8
kernel_name: vstore8_global_offset
arg_out: 0 buffer uchar[17] 0 0 0 0 0 0 0 0 0  58 246 32 180 21 63 255 53
arg_in:  1 buffer uchar8[1] 58 246 32 180 21 63 255 53

[test]
name: vector store global uchar16
kernel_name: vstore16_global
arg_out: 0 buffer uchar[17] 0 92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244
arg_in:  1 buffer uchar16[1] 92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244

[test]
name: vector store global offset uchar16
kernel_name: vstore16_global_offset
arg_out: 0 buffer uchar[33] 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244
arg_in:  1 buffer uchar16[1] 92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244

!*/

kernel void vstore2_global(global uchar *out,
                             global uchar2 *in) {
    uchar2 tmp = in[0];
    vstore2((uchar2)0, 0, out);
    vstore2(tmp, 0, out + 1);
}

kernel void vstore2_global_offset(global uchar *out,
                                    global uchar2 *in) {
    uchar2 tmp = (uchar2)0;
    vstore2(tmp, 0, out);
    vstore2(tmp, 0, out + 1);
    tmp = in[0];
    vstore2(tmp, 1, out + 1);
}

kernel void vstore4_global(global uchar *out,
                             global uchar4 *in) {
    uchar4 tmp = in[0];
    vstore4((uchar4)0, 0, out);
    vstore4(tmp, 0, out + 1);
}

kernel void vstore4_global_offset(global uchar *out,
                                    global uchar4 *in) {
    uchar4 tmp = (uchar4)0;
    vstore4(tmp, 0, out);
    vstore4(tmp, 0, out + 1);
    tmp = in[0];
    vstore4(tmp, 1, out + 1);
}

kernel void vstore8_global(global uchar *out,
                             global uchar8 *in) {
    uchar8 tmp = in[0];
    vstore8((uchar8)0, 0, out);
    vstore8(tmp, 0, out + 1);
}

kernel void vstore8_global_offset(global uchar *out,
                                    global uchar8 *in) {
    uchar8 tmp = (uchar8)0;
    vstore8(tmp, 0, out);
    vstore8(tmp, 0, out + 1);
    tmp = in[0];
    vstore8(tmp, 1, out + 1);
}

kernel void vstore16_global(global uchar *out,
                             global uchar16 *in) {
    uchar16 tmp = in[0];
    vstore16((uchar16)0, 0, out);
    vstore16(tmp, 0, out + 1);
}

kernel void vstore16_global_offset(global uchar *out,
                                    global uchar16 *in) {
    uchar16 tmp = (uchar16)0;
    vstore16(tmp, 0, out);
    vstore16(tmp, 0, out + 1);
    tmp = in[0];
    vstore16(tmp, 1, out + 1);
}
