
/*!
[config]
name: Vector store uint2,4,8,16
clc_version_min: 10

dimensions: 1
global_size: 1 0 0

[test]
name: vector store global uint2
kernel_name: vstore2_global
arg_out: 0 buffer uint[3] 0 244 242
arg_in:  1 buffer uint2[1] 244 242

[test]
name: vector store global offset uint2
kernel_name: vstore2_global_offset
arg_out: 0 buffer uint[5] 0 0 0  244 242
arg_in:  1 buffer uint2[1] 244 242

[test]
name: vector store global uint4
kernel_name: vstore4_global
arg_out: 0 buffer uint[5] 0 60 26 101 39
arg_in:  1 buffer uint4[1] 60 26 101 39

[test]
name: vector store global offset uint4
kernel_name: vstore4_global_offset
arg_out: 0 buffer uint[9] 0 0 0 0 0  60 26 101 39
arg_in:  1 buffer uint4[1] 60 26 101 39

[test]
name: vector store global uint8
kernel_name: vstore8_global
arg_out: 0 buffer uint[9] 0 58 246 32 180 21 63 255 53
arg_in:  1 buffer uint8[1] 58 246 32 180 21 63 255 53

[test]
name: vector store global offset uint8
kernel_name: vstore8_global_offset
arg_out: 0 buffer uint[17] 0 0 0 0 0 0 0 0 0  58 246 32 180 21 63 255 53
arg_in:  1 buffer uint8[1] 58 246 32 180 21 63 255 53

[test]
name: vector store global uint16
kernel_name: vstore16_global
arg_out: 0 buffer uint[17] 0 92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244
arg_in:  1 buffer uint16[1] 92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244

[test]
name: vector store global offset uint16
kernel_name: vstore16_global_offset
arg_out: 0 buffer uint[33] 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244
arg_in:  1 buffer uint16[1] 92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244

!*/

kernel void vstore2_global(global uint *out,
                             global uint2 *in) {
    uint2 tmp = in[0];
    vstore2((uint2)0, 0, out);
    vstore2(tmp, 0, out + 1);
}

kernel void vstore2_global_offset(global uint *out,
                                    global uint2 *in) {
    uint2 tmp = (uint2)0;
    vstore2(tmp, 0, out);
    vstore2(tmp, 0, out + 1);
    tmp = in[0];
    vstore2(tmp, 1, out + 1);
}

kernel void vstore4_global(global uint *out,
                             global uint4 *in) {
    uint4 tmp = in[0];
    vstore4((uint4)0, 0, out);
    vstore4(tmp, 0, out + 1);
}

kernel void vstore4_global_offset(global uint *out,
                                    global uint4 *in) {
    uint4 tmp = (uint4)0;
    vstore4(tmp, 0, out);
    vstore4(tmp, 0, out + 1);
    tmp = in[0];
    vstore4(tmp, 1, out + 1);
}

kernel void vstore8_global(global uint *out,
                             global uint8 *in) {
    uint8 tmp = in[0];
    vstore8((uint8)0, 0, out);
    vstore8(tmp, 0, out + 1);
}

kernel void vstore8_global_offset(global uint *out,
                                    global uint8 *in) {
    uint8 tmp = (uint8)0;
    vstore8(tmp, 0, out);
    vstore8(tmp, 0, out + 1);
    tmp = in[0];
    vstore8(tmp, 1, out + 1);
}

kernel void vstore16_global(global uint *out,
                             global uint16 *in) {
    uint16 tmp = in[0];
    vstore16((uint16)0, 0, out);
    vstore16(tmp, 0, out + 1);
}

kernel void vstore16_global_offset(global uint *out,
                                    global uint16 *in) {
    uint16 tmp = (uint16)0;
    vstore16(tmp, 0, out);
    vstore16(tmp, 0, out + 1);
    tmp = in[0];
    vstore16(tmp, 1, out + 1);
}
