
/*!
[config]
name: Vector store ushort2,4,8,16
clc_version_min: 10

dimensions: 1
global_size: 1 0 0

[test]
name: vector store global ushort2
kernel_name: vstore2_global
arg_out: 0 buffer ushort[3] 0 244 242
arg_in:  1 buffer ushort2[1] 244 242

[test]
name: vector store global offset ushort2
kernel_name: vstore2_global_offset
arg_out: 0 buffer ushort[5] 0 0 0  244 242
arg_in:  1 buffer ushort2[1] 244 242

[test]
name: vector store global ushort4
kernel_name: vstore4_global
arg_out: 0 buffer ushort[5] 0 60 26 101 39
arg_in:  1 buffer ushort4[1] 60 26 101 39

[test]
name: vector store global offset ushort4
kernel_name: vstore4_global_offset
arg_out: 0 buffer ushort[9] 0 0 0 0 0  60 26 101 39
arg_in:  1 buffer ushort4[1] 60 26 101 39

[test]
name: vector store global ushort8
kernel_name: vstore8_global
arg_out: 0 buffer ushort[9] 0 58 246 32 180 21 63 255 53
arg_in:  1 buffer ushort8[1] 58 246 32 180 21 63 255 53

[test]
name: vector store global offset ushort8
kernel_name: vstore8_global_offset
arg_out: 0 buffer ushort[17] 0 0 0 0 0 0 0 0 0  58 246 32 180 21 63 255 53
arg_in:  1 buffer ushort8[1] 58 246 32 180 21 63 255 53

[test]
name: vector store global ushort16
kernel_name: vstore16_global
arg_out: 0 buffer ushort[17] 0 92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244
arg_in:  1 buffer ushort16[1] 92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244

[test]
name: vector store global offset ushort16
kernel_name: vstore16_global_offset
arg_out: 0 buffer ushort[33] 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244
arg_in:  1 buffer ushort16[1] 92 123 106 114 104 168 66 162 2 77 85 36 190 79 202 244

!*/

kernel void vstore2_global(global ushort *out,
                             global ushort2 *in) {
    ushort2 tmp = in[0];
    vstore2((ushort2)0, 0, out);
    vstore2(tmp, 0, out + 1);
}

kernel void vstore2_global_offset(global ushort *out,
                                    global ushort2 *in) {
    ushort2 tmp = (ushort2)0;
    vstore2(tmp, 0, out);
    vstore2(tmp, 0, out + 1);
    tmp = in[0];
    vstore2(tmp, 1, out + 1);
}

kernel void vstore4_global(global ushort *out,
                             global ushort4 *in) {
    ushort4 tmp = in[0];
    vstore4((ushort4)0, 0, out);
    vstore4(tmp, 0, out + 1);
}

kernel void vstore4_global_offset(global ushort *out,
                                    global ushort4 *in) {
    ushort4 tmp = (ushort4)0;
    vstore4(tmp, 0, out);
    vstore4(tmp, 0, out + 1);
    tmp = in[0];
    vstore4(tmp, 1, out + 1);
}

kernel void vstore8_global(global ushort *out,
                             global ushort8 *in) {
    ushort8 tmp = in[0];
    vstore8((ushort8)0, 0, out);
    vstore8(tmp, 0, out + 1);
}

kernel void vstore8_global_offset(global ushort *out,
                                    global ushort8 *in) {
    ushort8 tmp = (ushort8)0;
    vstore8(tmp, 0, out);
    vstore8(tmp, 0, out + 1);
    tmp = in[0];
    vstore8(tmp, 1, out + 1);
}

kernel void vstore16_global(global ushort *out,
                             global ushort16 *in) {
    ushort16 tmp = in[0];
    vstore16((ushort16)0, 0, out);
    vstore16(tmp, 0, out + 1);
}

kernel void vstore16_global_offset(global ushort *out,
                                    global ushort16 *in) {
    ushort16 tmp = (ushort16)0;
    vstore16(tmp, 0, out);
    vstore16(tmp, 0, out + 1);
    tmp = in[0];
    vstore16(tmp, 1, out + 1);
}
